Calibre

De library staat op anduril: /usbdisk/shared/Boeken.

Calibre installatie

Installeren simpelweg apt-get install calibre.

Als daemon

Creer /etc/init.d/calibre, en maak hem executable:

#! /bin/sh
### BEGIN INIT INFO
# Provides:          calibre
# Required-Start:    network
# Required-Stop:
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Starts the Calibre Content Server
# Description:       Starts the calibre-content daemon, a Web server
#
### END INIT INFO
 
# Author: Pieter van der Meulen <pieter@vdmeulen.net>
#
# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Calibre content server"
NAME=calibre-server
DAEMON=/usr/bin/$NAME
PIDFILE=/var/run/$NAME.pid
CONTENT=/usbdisk/shared/Boeken
PORT=8080
DAEMON_ARGS="--with-library=$CONTENT --port=$PORT --pidfile=$PIDFILE --daemonize"
SCRIPTNAME=/etc/init.d/$NAME
 
# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0
 
# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
 
# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh
 
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions
 
#
# Function that starts the daemon/service
#
do_start()
{
        # Return
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
        start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null || return 1
        start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- $DAEMON_ARGS || return 2
}
 
#
# Function that stops the daemon/service
#
do_stop()
{
        # Return
        #   0 if daemon has been stopped
        #   1 if daemon was already stopped
        #   2 if daemon could not be stopped
        #   other if a failure occurred
        start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
        RETVAL="$?"
        [ "$RETVAL" = 2 ] && return 2
        # Wait for children to finish too if this is a daemon that forks
        # and if the daemon is only ever run from this initscript.
        # If the above conditions are not satisfied then add some other code
        # that waits for the process to drop all resources that could be
        # needed by services started subsequently.  A last resort is to
        # sleep for some time.
        start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
        [ "$?" = 2 ] && return 2
        # Many daemons don't delete their pidfiles when they exit.
        rm -f $PIDFILE
        return "$RETVAL"
}
 
#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
        #
        # If the daemon can reload its configuration without
        # restarting (for example, when it is sent a SIGHUP),
        # then implement that here.
        #
        start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
        return 0
}
 
case "$1" in
  start)
        [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
        do_start
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  stop)
        [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
        do_stop
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  status)
       status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
       ;;
  #reload|force-reload)
        #
        # If do_reload() is not implemented then leave this commented out
        # and leave 'force-reload' as an alias for 'restart'.
        #
        #log_daemon_msg "Reloading $DESC" "$NAME"
        #do_reload
        #log_end_msg $?
        #;;
  restart|force-reload)
        #
        # If the "reload" option is implemented then remove the
        # 'force-reload' alias
        #
        log_daemon_msg "Restarting $DESC" "$NAME"
        do_stop
        case "$?" in
          0|1)
                do_start
                case "$?" in
                        0) log_end_msg 0 ;;
                        1) log_end_msg 1 ;; # Old process is still running
                        *) log_end_msg 1 ;; # Failed to start
                esac
                ;;
          *)
                # Failed to stop
                log_end_msg 1
                ;;
        esac
        ;;
  *)
        #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
        echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
        exit 3
        ;;
esac
 
:

De content server kan nu worden gestart via: /etc/init.d/calibre start.

Integratie in apache

Zie http://calibre-ebook.com/user_manual/server.html

a2enmod proxy proxy_http
joe /etc/apache2/sites/available/calibre-server
a2ensite calibre-server

/etc/apache2/sites-avalable/calibre-server

<Location /calibre>
        ProxyPass http://localhost:8080/calibre
</Location>

Kranten

#!/bin/bash
DATE=`date +%Y-%m-%d`
#CALIBRE_DIR=/usr/share/calibre
RECIPES_DIR=/home/pieter/calibre
OUTPUT_DIR=/home/pieter/calibre
OUTPUT_PROFILE=kindle
OUTPUT_FILEEXT=mobi
 
unset DISPLAY
echo $DATE
echo "----------"
 
# Function that retrieves newspapers
function get_newspaper
{
  ebookfile="$OUTPUT_DIR/$2-$DATE.$OUTPUT_FILEEXT"
  zipfile="$OUTPUT_DIR/$2-$DATE.zip"
  cd /tmp
  if [ ! -f "$zipfile" ];then
    remove_old "$2"
    echo "Downloading latest issue of $2"
    ebook-convert "$RECIPES_DIR/$1" "$ebookfile" --output-profile $OUTPUT_PROFILE
    zip -m -7 -D "$zipfile" "$ebookfile"
  else
    echo "Not downloading $2: already done..."
  fi
  echo "Mailing $2 to $3"
  mutt -s "$2 $DATE" -a "$zipfile" -- $3 < /dev/null
}
 
function remove_old
{
  echo "Removing old issues of $1"
  while IFS= read -r -u3 -d $'\0' inputfile
  do
    rm "$inputfile"
  done 3< <(find "$OUTPUT_DIR" -iname "$1-*.zip" -type f -print0)               
}
 
mkdir -p $OUTPUT_DIR
 
#Get newspapers
get_newspaper volksrant.recipe "De Volkskrant" pieter.vd.meulen@free.kindle.com
#get_newspaper financieele_dagblad.recipe "FD" pieter.vd.meulen@free.kindle.com
#get_newspaper fd.recipe "FD" pieter.vd.meulen@free.kindle.com
get_newspaper dilbert.recipe Dilbert pieter.vd.meulen@free.kindle.com
 
get_newspaper volksrant.recipe "De Volkskrant" carola.vd.meulen@free.kindle.com

Boeken converteren voor de Kindle

#!/bin/bash
#This converts all epub documents in the calibre document root to mobi
#Ignores books that alrady have a mobi copy
DOCUMENT_DIR=/usbdisk/shared/Boeken
IN_EXT=epub
OUT_EXT=mobi
OUT_PROFILE=kindle
echo "Bestanden zoeken in $DOCUMENT_DIR"
 
while IFS= read -r -u3 -d $'\0' inputfile
do
    outputfile="${inputfile%.$IN_EXT}.$OUT_EXT"
    if [ ! -f "$outputfile" ]
	then
		echo "Converting $inputfile to $outputfile"
		ebook-convert "$inputfile" "$outputfile" --output-profile $OUT_PROFILE
	fi
done 3< <(find "$DOCUMENT_DIR" -iname '*.'$IN_EXT -type f -print0)

Crontab uitbreidingen

Toevoegen met crontab -e

# m h  dom mon dow   command
 33 5   *   *   *    $HOME/calibre/newspapers > $HOME/calibre/newspapers.log 2>&1
 30 4   *   *   1    $HOME/calibre/books > $HOME/calibre/books.log 2>&1

Kindle collections plugin

/share/Web/dokuwiki/data/pages/beheer/calibre.txt ยท Laatst gewijzigd: 2013/12/23 13:46 door pieter
CC Attribution-Share Alike 4.0 International
Powered by PHP Driven by DokuWiki Recent changes RSS feed Valid CSS Valid XHTML 1.0 Valid HTML5